<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _, { cloneDeep } from "lodash";
@Component({})
export default class AdminSettingsPaymentComponent extends Vue {
	config = {
		page: 1,
		limit: 25,
		search: "",
	};
	page = 1;

	listPaymentType = [
		{ name: "Stripe", value: "stripe" },
		{ name: "Paypal", value: "paypal" },
	];

	payment = {
		name: "",
		type: "paypal",
		enabled: true,
		publicKey: "",
		secretKey: "",
	};

	paymentDuplicate: any = {
		name: "",
		type: "paypal",
		enabled: true,
		publicKey: "",
		secretKey: "",
		policy: {},
	};

	get totalPage() {
		return this.$store.state.adminPayment.totalPage || 0;
	}

	get dialogAddPayment() {
		return this.$store.state.adminPayment.dialogAddPayment || false;
	}

	get dialogDuplicatePayment() {
		return this.$store.state.adminPayment.dialogDuplicatePayment || false;
	}

	set dialogDuplicatePayment(value) {
		this.$store.commit("adminPayment/setDialogDuplicatePayment", value);
	}

	get loadingTable() {
		return this.$store?.state?.adminPayment?.loadingTable || false;
	}

	loading = false;

	get listPayment() {
		const listPayment = cloneDeep(
			this.$store.state.adminPayment.listPayment
		);
		return listPayment || [];
	}

	mounted() {
		this.onGetListPayment();
	}

	async onGetListPayment() {
		this.$store.dispatch("adminPayment/onGetListPayment", {
			ctx: this,
			query: this.config,
		});
	}

	openDialogAddPayment() {
		this.$store.commit("adminPayment/setDialogAddPayment", true);
	}

	closeDialogAddPayment() {
		this.$store.commit("adminPayment/setDialogAddPayment", false);
		this.onResetPayment()
	}

	onResetPayment() {
		this.payment = {
			name: "",
			type: "paypal",
			enabled: true,
			publicKey: "",
			secretKey: "",
		};
	}

	async onAddPayment() {
		if (
			!(
				this.payment.name ||
				this.payment.publicKey ||
				this.payment.secretKey
			)
		) {
			return this.$pushNotification.error(
				"Please enter full information"
			);
		}
		this.loading = true;
		await this.$store
			.dispatch("adminPayment/onAddPayment", {
				ctx: this,
				payload: this.payment,
				query: this.config,
				type: "create",
			})
			.then(() => {
				this.onGetListPayment();
				this.onResetPayment()
			})
			.finally(() => {
				this.loading = false;
			});
	}

	openDialogDuplicate(payment: any) {
		this.$store.commit("adminPayment/setDialogDuplicatePayment", true);
		const { policyId: policy, type, enabled } = cloneDeep(payment);
		this.paymentDuplicate = {
			name: "",
			type,
			enabled,
			publicKey: "",
			secretKey: "",
			policy,
		};
	}

	closeDialogDuplicate() {
		this.$store.commit("adminPayment/setDialogDuplicatePayment", false);
		this.paymentDuplicate = {
			name: "",
			type: "paypal",
			enabled: true,
			publicKey: "",
			secretKey: "",
			policy: {},
		};
	}

	async onDuplicatePayment() {
		if (
			!(
				this.paymentDuplicate.name &&
				this.paymentDuplicate.publicKey &&
				this.paymentDuplicate.secretKey
			)
		) {
			return this.$pushNotification.error(
				"Please enter full information"
			);
		}
		this.loading = true;
		const {
			refund,
			privacy,
			shipping,
			terms,
			faqs,
			aboutUs,
			dmca,
			cancelAndOrderChange,
			paymentMethod,
		} = this.paymentDuplicate.policy;
		const payload = {
			...this.paymentDuplicate,
			policy: {
				refund,
				privacy,
				shipping,
				terms,
				faqs,
				aboutUs,
				dmca,
				cancelAndOrderChange,
				paymentMethod,
			},
		};
		await this.$store
			.dispatch("adminPayment/onAddPayment", {
				ctx: this,
				payload,
				query: this.config,
				type: "duplicate",
			})
			.then(() => {
				this.onGetListPayment();
			})
			.finally(() => {
				this.loading = false;
			});
	}

	async onChangeStatus(payment: any) {
		try {
			await this.$api.payment.update(payment._id, {
				enabled: payment.enabled,
			});
			this.$pushNotification.success("Change status successfully");
			this.onGetListPayment();
		} catch (error) {
			apiErrorHandler(error, this);
		}
	}

	onRedirectPage() {
		this.config.page = this.page;
		this.onGetListPayment();
	}

	calcLengthPolicy(payment: any) {
		let total = 0;
		if (payment.policyId) {
			const {
				refund,
				privacy,
				shipping,
				terms,
				faqs,
				aboutUs,
				dmca,
				cancelAndOrderChange,
				paymentMethod,
			} = payment;
			const policyId = {
				refund,
				privacy,
				shipping,
				terms,
				faqs,
				aboutUs,
				dmca,
				cancelAndOrderChange,
				paymentMethod,
			};
			for (let policy of Object.keys(policyId)) {
				if (payment.policyId[policy]) {
					total += 1;
				}
			}
		}
		return total;
	}

	@Watch("config.page")
	changedPage() {
		this.onGetListPayment();
	}
}
</script>

<style></style>

